unit plotteru;

{Zur Dokumentation siehe Basic Programm in der Fischertechnik Anleitung
Plotter-Scanner 39460, p entspricht +, m entspricht -}

INTERFACE

uses crt,fischer;       {fischer ist im Lucky Logic Paket enthalten}

var xout,yout,mg:boolean;
    xj,yj,xm,ym:integer;
    dt,d_mg:byte;
    xh,yh,xs,ys:real;
    dx,dy,d,nx,ny:real;

procedure p_x;
procedure m_x;
procedure p_y;
procedure m_y;
procedure home;
procedure move(x,y:real);
procedure origin;
procedure set_origin(x,y:real);
procedure scale(x1,x2,y1,y2:real);
procedure line(x,y:real);
procedure rline(x,y:real);
procedure rmove(x,y:real);
procedure box(xa,xe,ya,ye:real;s:integer);
procedure circle(x,y,rx,ry,wa,we:real);
procedure axis(xa,ya,xe,ye,x1,y1,x2,y2:real);


IMPLEMENTATION

{Elementare Bewegungen}

procedure mg_ein;
begin
     mg:=true;
     if not(xout or yout) then
        begin
             motor(4,rechts);
             delay(d_mg);
        end;
end;

procedure mg_aus;
begin
     mg:=false;
     motor(4,links);
     motor(4,aus);
     delay(d_mg);
end;

procedure mg_pause;
begin
     motor(4,aus);
     delay(d_mg);
end;

procedure justage_pruefung;
begin
     if (not taster(7) and (xj<>0)) or (not taster(8) and (yj<>0)) then
        begin
             writeln('Achtung Plotter ist dejustiert');
             halt;
        end;
end;

procedure range_pruefung;
var
   status_old,status_ist:boolean;
begin
     if xout or yout then status_old:=true else status_old:=false;
     xout:= (xj<0) or (xj>xm);
     yout:= (yj<0) or (yj>ym);
     if xout or yout then status_ist:=true else status_ist:=false;
     if status_ist then begin if not status_old then mg_pause end else
        if mg and status_old then mg_ein;
end;

procedure p_x_Sequenz;
begin
     motor(1,links) ;motor(2,rechts);motor(3,rechts);
     justage_pruefung;delay(dt);
     motor(1,links) ;motor(2,links) ;motor(3,rechts);
     justage_pruefung;delay(dt);
     motor(1,rechts);motor(2,links) ;motor(3,rechts);
     justage_pruefung;delay(dt);
     motor(1,rechts);motor(2,rechts);motor(3,rechts);
     justage_pruefung;delay(dt);
end;

procedure p_x;
begin
     xj:=xj+1;
     range_pruefung;
     if not xout then p_x_Sequenz;
end;

procedure m_x_Sequenz;
begin
     motor(1,rechts) ;motor(2,links);motor(3,rechts);
     justage_pruefung;delay(dt);
     motor(1,links) ;motor(2,links) ;motor(3,rechts);
     justage_pruefung;delay(dt);
     motor(1,links);motor(2,rechts) ;motor(3,rechts);
     justage_pruefung;delay(dt);
     motor(1,rechts);motor(2,rechts);motor(3,rechts);
     justage_pruefung;delay(dt);
end;

procedure m_x;
begin
     xj:=xj-1;
     range_pruefung;
     if not xout then m_x_Sequenz;
end;
                           
procedure p_y_Sequenz;
begin
     motor(1,links) ;motor(2,rechts);motor(3,rechts);
     justage_pruefung;delay(dt);
     motor(1,links) ;motor(2,rechts);motor(3,links) ;
     justage_pruefung;delay(dt);
     motor(1,rechts);motor(2,rechts);motor(3,links) ;
     justage_pruefung;delay(dt);
     motor(1,rechts);motor(2,rechts);motor(3,rechts);
     justage_pruefung;delay(dt);
end;

procedure p_y;
begin
     yj:=yj+1;
     range_pruefung;
     if not yout then p_y_Sequenz;
end;

procedure m_y_Sequenz;
begin
     motor(1,rechts) ;motor(2,rechts);motor(3,links);
     justage_pruefung;delay(dt);
     motor(1,links)  ;motor(2,rechts);motor(3,links);
     justage_pruefung;delay(dt);
     motor(1,links) ;motor(2,rechts);motor(3,rechts);
     justage_pruefung;delay(dt);
     motor(1,rechts);motor(2,rechts);motor(3,rechts);
     justage_pruefung;delay(dt);
end;

procedure m_y;
begin
     yj:=yj-1;
     range_pruefung;
     if not yout then m_y_Sequenz;
end;

procedure p_x_p_y_Sequenz;
begin
     motor(1,links) ;motor(2,rechts);motor(3,rechts);
     justage_pruefung;delay(dt);
     motor(1,links)  ;motor(2,links);motor(3,links);
     justage_pruefung;delay(dt);
     motor(1,rechts) ;motor(2,links);motor(3,links);
     justage_pruefung;delay(dt);
     motor(1,rechts);motor(2,rechts);motor(3,rechts);
     justage_pruefung;delay(dt);
end;

procedure p_x_p_y;
begin
     xj:=xj+1;
     yj:=yj+1;
     range_pruefung;
     if not (xout or yout) then p_x_p_y_Sequenz;
     if xout and not yout then p_y_Sequenz;
     if yout and not xout then p_x_Sequenz;
end;

procedure p_x_m_y_Sequenz;
begin
     motor(1,rechts) ;motor(2,rechts);motor(3,links);
     justage_pruefung;delay(dt);
     motor(1,links)  ;motor(2,rechts);motor(3,links);
     justage_pruefung;delay(dt);
     motor(1,links) ;motor(2,links);motor(3,rechts);
     justage_pruefung;delay(dt);
     motor(1,rechts);motor(2,links);motor(3,rechts);
     justage_pruefung;delay(dt);
     motor(1,rechts) ;motor(2,rechts);motor(3,rechts);
     justage_pruefung;delay(dt);
end;

procedure p_x_m_y;
begin
     xj:=xj+1;
     yj:=yj-1;
     range_pruefung;
     if not (xout or yout) then p_x_m_y_Sequenz;
     if xout and not yout then m_y_Sequenz;
     if yout and not xout then p_x_Sequenz;
end;

procedure m_x_p_y_Sequenz;
begin
     motor(1,rechts) ;motor(2,links);motor(3,rechts);
     justage_pruefung;delay(dt);
     motor(1,links)  ;motor(2,links);motor(3,rechts);
     justage_pruefung;delay(dt);
     motor(1,links) ;motor(2,rechts);motor(3,links);
     justage_pruefung;delay(dt);
     motor(1,rechts);motor(2,rechts);motor(3,links);
     justage_pruefung;delay(dt);
     motor(1,rechts) ;motor(2,rechts);motor(3,rechts);
     justage_pruefung;delay(dt);
end;

procedure m_x_p_y;
begin
     xj:=xj-1;
     yj:=yj+1;
     range_pruefung;
     if not (xout or yout) then m_x_p_y_Sequenz;
     if xout and not yout then p_y_Sequenz;
     if yout and not xout then m_x_Sequenz;
end;

procedure m_x_m_y_Sequenz;
begin
     motor(1,rechts) ;motor(2,links);motor(3,links);
     justage_pruefung;delay(dt);
     motor(1,links)  ;motor(2,links);motor(3,links);
     justage_pruefung;delay(dt);
     motor(1,links) ;motor(2,rechts);motor(3,rechts);
     justage_pruefung;delay(dt);
     motor(1,rechts);motor(2,rechts);motor(3,rechts);
     justage_pruefung;delay(dt);
end;

procedure m_x_m_y;
begin
     xj:=xj-1;
     yj:=yj-1;
     range_pruefung;
     if not (xout or yout) then m_x_m_y_Sequenz;
     if xout and not yout then m_y_Sequenz;
     if yout and not xout then m_x_Sequenz;
end;

{Einfache Kommandos}

procedure home;
begin
     mg_aus;
     xj:=0;
     yj:=0;
     while taster(7) and taster(8) do m_x_m_y_Sequenz;
     while taster(7) do m_x_Sequenz;
     while not taster(7) do p_x_Sequenz;
     while taster(8) do m_y_Sequenz;
     while not taster(8) do p_y_Sequenz;
     p_x_p_y_Sequenz;p_x_p_y_Sequenz;
     xm:=1200; {xm und ym sind hier an meinen speziellen Plotter Aufbau}
     ym:=1000; {mit einem Motor mit einer Schrittweite von 3,75 (2 Strnge,
     xh:=0;    {Strangwiderstand 60 Ohm) angepat}
     yh:=0;
     xs:=1;
     ys:=1;
     xout:=false;
     yout:=false;
end;

procedure x_s(x:real);
begin
     if x>0 then p_x;
     if x<0 then m_x;
     nx:=nx+1;
     d:=d+dy;
end;

procedure y_s(y:real);
begin
     if y>0 then p_y;
     if y<0 then m_y;
     ny:=ny+1;
     d:=d-dx;
end;

procedure d_s(x,y:real);
begin
     if (x>0) and (y>0) then p_x_p_y;
     if (x<0) and (y>0) then m_x_p_y;
     if (x>0) and (y<0) then p_x_m_y;
     if (x<0) and (y<0) then m_x_m_y;
     nx:=nx+1;
     ny:=ny+1;
     d:=d+dy-dx;
end;

procedure rline_unsichtbar(x,y:real);
begin
     dx:=abs(x);
     dy:=abs(y);
     nx:=0;
     ny:=0;
     d:=0;
     while not ((nx=dx) and (ny=dy)) do
     if abs(d + dy) < abs(d + dy - dx) then x_s(x) else
     if abs(d - dx) < abs(d + dy - dx) then y_s(y) else d_s(x,y);
end;

procedure linie_unsichtbar(x,y:real);
begin
     x:=int(xh + xs * x - xj + 0.5);
     y:=int(yh + ys * y - yj + 0.5);
     rline_unsichtbar(x,y);
end;

procedure move(x,y:real);
begin
     mg_aus;
     linie_unsichtbar(x,y);
end;

procedure origin;
begin
     mg_aus;
     move(0,0);
end;

procedure set_origin(x,y:real);
begin
     xh:=xh + x * xs;
     yh:=yh + y * ys;
end;

procedure scale(x1,x2,y1,y2:real);
begin
     if (x1<x2) and (y1<y2) then
     begin
          xs:=xm/(x2-x1);
          ys:=ym/(y2-y1);
          xh:=-x1 * xs;
          yh:=-y1 * ys;
     end else
         begin
              writeln('Skalierungsfehler');
              halt;
         end;
end;

procedure line(x,y:real);
begin
     mg_ein;
     linie_unsichtbar(x,y);
end;

procedure rline_aus(x,y:real);
begin
     x:=int(xs * x + 0.5);
     y:=int(ys * y + 0.5);
     rline_unsichtbar(x,y);
end;

procedure rline(x,y:real);
begin
     mg_ein;
     rline_aus(x,y);
end;

procedure rmove(x,y:real);
begin
     mg_aus;
     rline_aus(x,y);
end;

{Plotter Tools}

procedure box(xa,xe,ya,ye:real;s:integer);
var
   x,y,xd:real;
begin
     if xa>xe then
        begin
             x:=xe;
             xe:=xa;
             xa:=x;
        end;
     if ya>ye then
        begin
             y:=ye;
             ye:=ya;
             ya:=y;
        end;
     move(xa,ya);
     line(xa,ye);
     line(xe,ye);
     line(xe,ya);
     line(xa,ya);
     if s<>0 then
        begin
             xd:=0;
             while xd<=(xe-xa)+(ye-ya) do
                   begin
                        if xd<(ye-ya) then
                           begin
                                x:=xa;
                                y:=ye-xd;
                           end else
                           begin
                                x:=xa+xd+ya-ye;
                                y:=ya;
                           end;

                        if s<0 then y:=ye+ya-y;

                        move(x,y);

                        if xd>(xe-xa) then
                           begin
                                x:=xe;
                                y:=ye+xe-xa-xd;
                           end else
                           begin
                                x:=xa+xd;
                                y:=ye;
                           end;

                        if s<0 then y:=ye+ya-y;

                        line(x,y);

                        xd:=xd+abs(s);

                   end;{end while}
        end;{end if}
end;


procedure circle(x,y,rx,ry,wa,we:real);

var
   xa,ya,ws,w:real;
begin
     rx:=abs(rx);
     ry:=abs(ry);
     xa:=x;
     ya:=y;
     x:=xa+rx*cos(arctan(1)*wa/45);
     y:=ya+ry*sin(arctan(1)*wa/45);
     move(x,y);
     w:=wa;
     if we>wa then ws:=(800/(rx*xs+ry*ys+40))
              else ws:=-(800/(rx*xs+ry*ys+40));
     while abs(w)<abs(we) do
     begin
          x:=xa+rx*cos(arctan(1)*w/45);
          y:=ya+ry*sin(arctan(1)*w/45);
          line(x,y);
          w:=w+ws
     end;
     x:=xa+rx*cos(arctan(1)*we/45);
     y:=ya+ry*sin(arctan(1)*we/45);
     line(x,y);
end;

procedure axis(xa,ya,xe,ye,x1,y1,x2,y2:real);
var
   x0,x3,y0,y3:real;
begin
     x0:=x1-(x2-x1)*(xa+xh/xs)/(xe-xa);
     x3:=x2+(x2-x1)*((xm-xh)/xs-xe)/(xe-xa);
     y0:=y1-(y2-y1)*(ya+yh/ys)/(ye-ya);
     y3:=y2+(y2-y1)*((ym-yh)/ys-ye)/(ye-ya);

     xs:=xm/(x3-x0);
     ys:=ym/(y3-y0);

     xh:=-x0*xs;
     yh:=-y0*ys;

     if not((y1>0) or (y2<0)) then
     begin
          move(x1,0);
          line(x2,0);
          rline(-10/xs,5/ys);
          rmove(10/xs,-5/ys);
          rline(-10/xs,-5/ys);
     end;

     if not((x1>0) or (x2<0)) then
     begin
          move(0,y1);
          line(0,y2);
          rline(-5/xs,-10/ys);
          rmove(5/xs,10/ys);
          rline(5/xs,-10/ys);
     end;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++}
{Initialisierung}
begin
     dt:=10;
     d_mg:=100;
     home;
end.

